Loading...
Searching...
No Matches
casacore::SiscoStMan Class Referencefinal

The Stokes I storage manager behaves like a full set of (4) polarizations but only stores the Stokes I value on disk. More...

`#include <SiscoStMan.h>`

## Public Member Functions

| SiscoStMan (const casacore::String &name, const casacore::Record &spec)
| This constructor is called by Casacore when it needs to create a SiscoStMan.
| SiscoStMan (const SiscoStMan &source)
| Copy constructor that initializes a storage manager with similar specs.
| ~SiscoStMan () noexcept
SiscoStMan & | operator= (const SiscoStMan &source)=delete
| This SiscoStMan takes the settings of the source (but not the columns and/or data).
casacore::DataManager * | clone () const final
| Make a clone of the derived object.
casacore::String | dataManagerType () const final
| Return the type name of the data manager (in fact its class name).
casacore::Record | dataManagerSpec () const final
| Return a record containing data manager specifications.
bool | canAddRow () const final
| Does the data manager allow to add rows?
bool | canRemoveRow () const final
| Does the data manager allow to delete rows?
bool | canAddColumn () const final
| Does the data manager allow to add columns?
bool | canRemoveColumn () const final
| Does the data manager allow to delete columns?
int | DeflateLevel () const
int | PredictLevel () const
Public Member Functions inherited from casacore::DataManager
| DataManager ()
| Default constructor.
virtual | ~DataManager ()
| DataManager (const DataManager &)=delete
| The copy constructor cannot be used for this base class.
DataManager & | operator= (const DataManager &)=delete
| Assignment cannot be used for this base class.
virtual String | dataManagerName () const
| Return the name of the data manager.
void | dataManagerInfo (Record &info) const
| Add SEQNR and SPEC (the DataManagerSpec subrecord) to the info.
virtual Record | getProperties () const
| Get data manager properties that can be modified.
virtual void | setProperties (const Record &spec)
| Modify data manager properties given in record fields.
virtual Bool | isStorageManager () const
| Is the data manager a storage manager?
virtual Bool | canReallocateColumns () const
| Tell if the data manager wants to reallocate the data manager column objects.
virtual DataManagerColumn * | reallocateColumn (DataManagerColumn *column)
| Reallocate the column object if it is part of this data manager.
uInt | sequenceNr () const
| Get the (unique) sequence nr of this data manager.
uInt | ncolumn () const
| Get the nr of columns in this data manager (can be zero).
Bool | asBigEndian () const
| Have the data to be stored in big or little endian canonical format?
const TSMOption & | tsmOption () const
| Get the TSM option.
std::shared_ptr< MultiFileBase > | multiFile ()
| Get the MultiFile pointer (can be 0).
String | keywordName (const String &keyword) const
| Compose a keyword name from the given keyword appended with the sequence number (e.g.
String | fileName () const
| Compose a unique filename from the table name and sequence number.
ByteIO::OpenOption | fileOption () const
| Get the AipsIO option of the underlying file.
virtual Bool | isRegular () const
| Is this a regular storage manager?
Table & | table () const
| Get the table this object is associated with.
virtual Bool | canRenameColumn () const
| Does the data manager allow to rename columns?
virtual void | setMaximumCacheSize (uInt nMiB)
| Set the maximum cache size (in bytes) to be used by a storage manager.
virtual void | showCacheStatistics (std::ostream &) const
| Show the data manager's IO statistics.
DataManagerColumn * | createScalarColumn (const String &columnName, int dataType, const String &dataTypeId)
| Create a column in the data manager on behalf of a table column.
DataManagerColumn * | createDirArrColumn (const String &columnName, int dataType, const String &dataTypeId)
| Create a direct array column.
DataManagerColumn * | createIndArrColumn (const String &columnName, int dataType, const String &dataTypeId)
| Create an indirect array column.
DataManager * | getClone () const
| Has the object already been cloned?
void | setClone (DataManager *clone) const
| Set the pointer to the clone.

## Static Public Member Functions

static casacore::DataManager * | makeObject (const casacore::String &name, const casacore::Record &spec)
| Create an object with given name and spec.
static void | registerClass ()
| This function makes the SiscoStMan known to Casacore.
Static Public Member Functions inherited from casacore::DataManager
static void | registerCtor (const String &type, DataManagerCtor func)
| Register a mapping of a data manager type to its static construction function.
static DataManagerCtor | getCtor (const String &dataManagerType)
| Get the "constructor" of a data manager (thread-safe).
static Bool | isRegistered (const String &dataManagerType)
| Test if a data manager is registered (thread-safe).
static DataManager * | unknownDataManager (const String &dataManagerType, const Record &spec)
| Serve as default function for theirRegisterMap, which catches all unknown data manager types.

## Private Member Functions

casacore::Bool | flush (casacore::AipsIO &, casacore::Bool doFsync) final
| Flush and optionally fsync the data.
void | create64 (casacore::rownr_t nRow) final
| Let the storage manager create files as needed for a new table.
casacore::rownr_t | open64 (casacore::rownr_t nRow, casacore::AipsIO &) final
| Open the storage manager file for an existing table.
casacore::DataManagerColumn * | makeScalarColumn (const casacore::String &name, int dataType, const casacore::String &dataTypeID) final
| Create a column in the storage manager on behalf of a table column.
casacore::DataManagerColumn * | makeDirArrColumn (const casacore::String &name, int dataType, const casacore::String &dataTypeID) final
| Create a direct array column.
casacore::DataManagerColumn * | makeIndArrColumn (const casacore::String &name, int dataType, const casacore::String &dataTypeID) final
| Create an indirect array column.
casacore::rownr_t | resync64 (casacore::rownr_t nRow) final
| Resync the data by rereading cached data from the file.
void | deleteManager () final
| The data manager will be deleted (because all its columns are requested to be deleted).
void | prepare () final
| Prepare the columns, let the data manager initialize itself further.
void | reopenRW () final
| Reopen the storage manager files for read/write.
void | addRow64 (casacore::rownr_t nrrow) final
| Add rows to the storage manager.
void | removeRow64 (casacore::rownr_t row_nr) final
| Delete a row from all columns.
void | addColumn (casacore::DataManagerColumn *) final
| Do the final addition of a column.
void | removeColumn (casacore::DataManagerColumn *) final
| Remove a column from the data file.

## Private Attributes

std::string | name_
std::unique_ptr< SiscoStManColumn > | column_
| The item-type needs to be a pointer, because casacore::StManColumn does not have move construct/assignment.
int | deflate_level_
int | predict_level_
SiscoStoreMode | store_mode_

## Friends

class | SiscoStManColumn

## Additional Inherited Members

Static Public Attributes inherited from casacore::DataManager
static rownr_t | MAXROWNR32
| Define the highest row number that can be represented as signed 32-bit.
Protected Member Functions inherited from casacore::DataManager
void | decrementNcolumn ()
| Decrement number of columns (in case a column is deleted).
void | setEndian (Bool bigEndian)
| Tell the data manager if big or little endian format is needed.
void | setTsmOption (const TSMOption &tsmOption)
| Tell the data manager which TSM option to use.
void | setMultiFile (const std::shared_ptr< MultiFileBase > &mfile)
| Tell the data manager that MultiFile can be used.
virtual Bool | hasMultiFileSupport () const
| Does the data manager support use of MultiFile?
void | throwDataTypeOther (const String &columnName, int dataType) const
| Throw an exception in case data type is TpOther, because the storage managers (and maybe other data managers) do not support such columns.

## Detailed Description

The Stokes I storage manager behaves like a full set of (4) polarizations but only stores the Stokes I value on disk.

Definition at line 26 of file SiscoStMan.h.

## Constructor & Destructor Documentation

## SiscoStMan() [1/2]

casacore::SiscoStMan::SiscoStMan | ( | const casacore::String & | name,
|  | const casacore::Record & | spec )

This constructor is called by Casacore when it needs to create a SiscoStMan.

When Casacore loads an SiscoStMan for an existing MS, the "spec" parameter will be empty, thus the class should initialize its properties by reading them from the file. The `spec` is used to make a new storage manager with specs similar to another one.

Parameters

  name | Name of this storage manager.
  spec | Specs to initialize this class with.

References casacore::name(), and casacore::Record().

Referenced by clone(), makeObject(), operator=(), and SiscoStMan().

## SiscoStMan() [2/2]

casacore::SiscoStMan::SiscoStMan | ( | const SiscoStMan & | source | ) |

Copy constructor that initializes a storage manager with similar specs.

The columns are not copied: the new manager will be empty.

References SiscoStMan().

## ~SiscoStMan()

casacore::SiscoStMan::~SiscoStMan | ( |  | ) |

noexcept

## Member Function Documentation

## addColumn()

void casacore::SiscoStMan::addColumn | ( | casacore::DataManagerColumn * |  | ) |

final private virtual

Do the final addition of a column.

Reimplemented from casacore::DataManager.

References addColumn().

Referenced by addColumn().

## addRow64()

void casacore::SiscoStMan::addRow64 | ( | casacore::rownr_t | nrrow | ) |

final private virtual

Add rows to the storage manager.

Reimplemented from casacore::DataManager.

References addRow64().

Referenced by addRow64().

## canAddColumn()

bool casacore::SiscoStMan::canAddColumn | ( |  | ) | const

inline final virtual

Does the data manager allow to add columns?

(default no)

Reimplemented from casacore::DataManager.

Definition at line 75 of file SiscoStMan.h.

References column_.

## canAddRow()

bool casacore::SiscoStMan::canAddRow | ( |  | ) | const

inline final virtual

Does the data manager allow to add rows?

(default no)

Reimplemented from casacore::DataManager.

Definition at line 71 of file SiscoStMan.h.

References canAddRow().

Referenced by canAddRow().

## canRemoveColumn()

bool casacore::SiscoStMan::canRemoveColumn | ( |  | ) | const

inline final virtual

Does the data manager allow to delete columns?

(default no)

Reimplemented from casacore::DataManager.

Definition at line 77 of file SiscoStMan.h.

References column_.

## canRemoveRow()

bool casacore::SiscoStMan::canRemoveRow | ( |  | ) | const

inline final virtual

Does the data manager allow to delete rows?

(default no)

Reimplemented from casacore::DataManager.

Definition at line 73 of file SiscoStMan.h.

## clone()

casacore::DataManager * casacore::SiscoStMan::clone | ( |  | ) | const

inline final virtual

Make a clone of the derived object.

Implements casacore::DataManager.

Definition at line 53 of file SiscoStMan.h.

References clone(), casacore::DataManager::DataManager(), and SiscoStMan().

Referenced by clone().

## create64()

void casacore::SiscoStMan::create64 | ( | casacore::rownr_t | nRow | ) |

final private virtual

Let the storage manager create files as needed for a new table.

This allows a column with an indirect array to create its file.

Reimplemented from casacore::DataManager.

## dataManagerSpec()

casacore::Record casacore::SiscoStMan::dataManagerSpec | ( |  | ) | const

final virtual

Return a record containing data manager specifications.

The default implementation returns an empty record.

Reimplemented from casacore::DataManager.

References casacore::Record().

## dataManagerType()

casacore::String casacore::SiscoStMan::dataManagerType | ( |  | ) | const

inline final virtual

Return the type name of the data manager (in fact its class name).

It has to be a unique name, thus if the class is templated the template parameter has to be part of the name. This is used by the open/flush mechanism to be able to reconstruct the correct data manager.

Implements casacore::DataManager.

Definition at line 67 of file SiscoStMan.h.

## DeflateLevel()

int casacore::SiscoStMan::DeflateLevel | ( |  | ) | const

inline

Definition at line 84 of file SiscoStMan.h.

References deflate_level_.

## deleteManager()

void casacore::SiscoStMan::deleteManager | ( |  | ) |

final private virtual

The data manager will be deleted (because all its columns are requested to be deleted).

So clean up the things needed (e.g. delete files).

Implements casacore::DataManager.

## flush()

casacore::Bool casacore::SiscoStMan::flush | ( | casacore::AipsIO & | ios,
|  | casacore::Bool | fsync )

inline final private virtual

Flush and optionally fsync the data.

The AipsIO stream represents the main table file and can be used by virtual column engines to store SMALL amounts of data. It returns a True status if it had to flush (i.e. if data have changed).

Implements casacore::DataManager.

Definition at line 91 of file SiscoStMan.h.

## makeDirArrColumn()

casacore::DataManagerColumn * casacore::SiscoStMan::makeDirArrColumn | ( | const casacore::String & | name,
|  | int | dataType,
|  | const casacore::String & | dataTypeID )

final private virtual

Create a direct array column.

Implements casacore::DataManager.

References casacore::dataType(), and casacore::name().

## makeIndArrColumn()

casacore::DataManagerColumn * casacore::SiscoStMan::makeIndArrColumn | ( | const casacore::String & | name,
|  | int | dataType,
|  | const casacore::String & | dataTypeID )

final private virtual

Create an indirect array column.

Implements casacore::DataManager.

References casacore::dataType(), and casacore::name().

## makeObject()

casacore::DataManager * casacore::SiscoStMan::makeObject | ( | const casacore::String & | name,
|  | const casacore::Record & | spec )

inline static

Create an object with given name and spec.

This methods gets registered in the DataManager "constructor" map. The caller has to delete the object. New class will be initialized via SiscoStMan(const casacore::String& name, const casacore::Record& spec).

Returns
  A SiscoStMan with given specs.

Definition at line 62 of file SiscoStMan.h.

References casacore::name(), casacore::Record(), and SiscoStMan().

## makeScalarColumn()

casacore::DataManagerColumn * casacore::SiscoStMan::makeScalarColumn | ( | const casacore::String & | name,
|  | int | dataType,
|  | const casacore::String & | dataTypeID )

final private virtual

Create a column in the storage manager on behalf of a table column.

The caller will NOT delete the newly created object. Create a scalar column.

Implements casacore::DataManager.

References casacore::dataType(), and casacore::name().

## open64()

casacore::rownr_t casacore::SiscoStMan::open64 | ( | casacore::rownr_t | nRow,
|  | casacore::AipsIO & | )

final private virtual

Open the storage manager file for an existing table.

Return the number of rows in the data file.

Reimplemented from casacore::DataManager.

## operator=()

SiscoStMan & casacore::SiscoStMan::operator= | ( | const SiscoStMan & | source | ) |

delete

This SiscoStMan takes the settings of the source (but not the columns and/or data).

References SiscoStMan().

## PredictLevel()

int casacore::SiscoStMan::PredictLevel | ( |  | ) | const

inline

Definition at line 85 of file SiscoStMan.h.

References predict_level_.

## prepare()

void casacore::SiscoStMan::prepare | ( |  | ) |

final private virtual

Prepare the columns, let the data manager initialize itself further.

Prepare is called after create/open has been called for all columns. In this way one can be sure that referenced columns are read back and partly initialized.

Reimplemented from casacore::DataManager.

References prepare().

Referenced by prepare().

## registerClass()

void casacore::SiscoStMan::registerClass | ( |  | ) |

static

This function makes the SiscoStMan known to Casacore.

## removeColumn()

void casacore::SiscoStMan::removeColumn | ( | casacore::DataManagerColumn * |  | ) |

final private virtual

Remove a column from the data file.

Reimplemented from casacore::DataManager.

References removeColumn().

Referenced by removeColumn().

## removeRow64()

void casacore::SiscoStMan::removeRow64 | ( | casacore::rownr_t | row_nr | ) |

final private virtual

Delete a row from all columns.

Reimplemented from casacore::DataManager.

References removeRow64().

Referenced by removeRow64().

## reopenRW()

void casacore::SiscoStMan::reopenRW | ( |  | ) |

final private virtual

Reopen the storage manager files for read/write.

Reimplemented from casacore::DataManager.

References reopenRW().

Referenced by reopenRW().

## resync64()

casacore::rownr_t casacore::SiscoStMan::resync64 | ( | casacore::rownr_t | nrrow | ) |

final private virtual

Resync the data by rereading cached data from the file.

This is called when a lock is acquired on the file and it appears that data in this data manager has been changed by another process.
The data manager returns 0 or the number of rows it thinks there are. This is particularly useful for data managers like LofarStMan whose data are written outside the table system, thus for which no rows have been added.
The default implementation calls the uInt version of resync and resync1.

Reimplemented from casacore::DataManager.

## Friends And Related Symbol Documentation

## SiscoStManColumn

friend class SiscoStManColumn

friend

Definition at line 89 of file SiscoStMan.h.

References SiscoStManColumn.

Referenced by SiscoStManColumn.

## Member Data Documentation

## column_

std::unique_ptr<SiscoStManColumn> casacore::SiscoStMan::column_

private

The item-type needs to be a pointer, because casacore::StManColumn does not have move construct/assignment.

Definition at line 149 of file SiscoStMan.h.

Referenced by canAddColumn(), and canRemoveColumn().

## deflate_level_

int casacore::SiscoStMan::deflate_level_

private

Definition at line 150 of file SiscoStMan.h.

Referenced by DeflateLevel().

## name_

std::string casacore::SiscoStMan::name_

private

Definition at line 146 of file SiscoStMan.h.

## predict_level_

int casacore::SiscoStMan::predict_level_

private

Definition at line 151 of file SiscoStMan.h.

Referenced by PredictLevel().

## store_mode_

SiscoStoreMode casacore::SiscoStMan::store_mode_

private

Definition at line 152 of file SiscoStMan.h.

The documentation for this class was generated from the following file:

- tables/AlternateMans/SiscoStMan.h